/* 
**  mod_crowd.c -- Apache sample crowd module
**  [Autogenerated via ``apxs -n crowd -g'']
**
**  To play with this sample module first compile it into a
**  DSO file and install it into Apache's modules directory 
**  by running:
**
**    $ apxs -c -i mod_crowd.c
**
**  Then activate it in Apache's httpd.conf file for instance
**  for the URL /crowd in as follows:
**
**    #   httpd.conf
**    LoadModule crowd_module modules/mod_crowd.so
**    <Location /crowd>
**    SetHandler crowd
**    </Location>
**
**  Then after restarting Apache via
**
**    $ apachectl restart
**
**  you immediately can request the URL /crowd and watch for the
**  output of this module. This can be achieved for instance via:
**
**    $ lynx -mime_header http://localhost/crowd 
**
**  The output should be similar to the following one:
**
**    HTTP/1.1 200 OK
**    Date: Tue, 31 Mar 1998 14:42:22 GMT
**    Server: Apache/1.3.4 (Unix)
**    Connection: close
**    Content-Type: text/html
**  
**    The sample page from mod_crowd.c
*/ 


/*
 * http_auth: authentication
 * 
 * Rob McCool
 * 
 * Adapted to Apache by rst.
 *
 * dirkx - Added Authoritative control to allow passing on to lower
 *         modules if and only if the userid is not known to this
 *         module. A known user with a faulty or absent password still
 *         causes an AuthRequired. The default is 'Authoritative', i.e.
 *         no control is passed along.
 */

#include "apr_strings.h"
#include "apr_md5.h"            /* for apr_password_validate */

#include "ap_config.h"
#include "httpd.h"
#include "http_config.h"
#include "http_core.h"
#include "http_log.h"
#include "http_protocol.h"
#include "http_request.h"


#include <stdio.h>
#include "soapH.h"
#include "SecurityServerHttpBinding.nsmap"


static char *lookup_header(request_rec *r, const char *name);

/********************CROWD SOAP CALL FUNCS**************************/


char* authenticateApplication(char *inAddress, char *inAppName, 
        char *inAppPassword, char *remoteAddress,
        char *agent, char *remoteAddressXForwardFor);
char* getDomain(char *inAddress, char *inAppName, 
        char *inAppToken);
int isValidPrincipalToken(char *inAddress, char *inAppName, 
        char *inAppToken, char *inCookeValPrincipalToken, char *remoteAddress,
        char *agent, char *remoteAddressXForwardFor);
char* authenticatePrincipal(char *inAddress, char *inAppName, 
        char *inAppToken, char *inPrincipalName, char *inPrincipalPassword, 
        char *remoteAddress, char *agent, char *remoteAddressXForwardFor);
char* strcopy2(char *dest);




char* authenticatePrincipal(char *inAddress, char *inAppName, 
        char *inAppToken, char *inPrincipalName, char *inPrincipalPassword, 
        char *remoteAddress, char *agent, char *remoteAddressXForwardFor)
{
char *strNew = NULL;
int i = 0;
int totFactorsIdx = 0;
int totFactors = 0;

if(agent!=NULL){
totFactors++;
}

if(remoteAddress!=NULL){
totFactors++;
}

if(remoteAddressXForwardFor != NULL && remoteAddress != NULL &&  0 != strcmp (remoteAddress, remoteAddressXForwardFor)){
totFactors++;
}

printf("totFactors=%d",totFactors);
printf("%d at 6\n",i++);
    struct soap *soap = soap_new1(SOAP_IO_DEFAULT); 
printf("%d at 6\n",i++);
    struct _ns1__authenticatePrincipalResponse ns1__authenticatePrincipalResponse;
printf("%d at 6\n",i++);
    struct _ns1__authenticatePrincipal ns1__authenticatePrincipal;
printf("%d at 6\n",i++);
    struct ns2__AuthenticatedToken in0;
printf("%d at 6\n",i++);
    struct ns2__PrincipalAuthenticationContext in1;
printf("%d at 6\n",i++);
    struct ns2__ArrayOfValidationFactor validationFactors;
printf("%d at 6\n",i++);
    struct ns2__ValidationFactor ValidationFactor[3];
printf("%d at 6\n",i++);
    struct ns2__PasswordCredential credential;
printf("%d at 6\n",i++);





if(agent!=NULL){
printf("%d at 6\n",i++);
    ValidationFactor[totFactorsIdx].name="User-Agent";
printf("%d at 6\n",i++);
    ValidationFactor[totFactorsIdx].value=agent;
printf("%d at 6\n",i++);
totFactorsIdx++;
}

if(remoteAddress!=NULL){
printf("%d at 6\n",i++);
    ValidationFactor[totFactorsIdx].name="remote_address";
printf("%d at 6\n",i++);
    ValidationFactor[totFactorsIdx].value=remoteAddress;
printf("%d at 6\n",i++);
totFactorsIdx++;
}

if(remoteAddressXForwardFor != NULL && remoteAddress != NULL &&  0 != strcmp (remoteAddress, remoteAddressXForwardFor)){
    ValidationFactor[totFactorsIdx].name="X-Forwarded-For";
printf("%d at 6\n",i++);
    ValidationFactor[totFactorsIdx].value=remoteAddressXForwardFor;
printf("%d at 6\n",i++);
totFactorsIdx++;
}


printf("%d at 6\n",i++);
    validationFactors.__sizeValidationFactor=totFactors;
printf("%d at 6\n",i++);
    validationFactors.ValidationFactor=ValidationFactor;
printf("%d at 6\n",i++);
    credential.credential=inPrincipalPassword;
printf("%d at 6\n",i++);


in0.name = inAppName;
printf("%d at 6\n",i++);
in0.token = inAppToken;
printf("%d at 6\n",i++);
in1.application = inAppName;
printf("%d at 6\n",i++);
in1.credential = &credential;
printf("%d at 6\n",i++);
in1.name = inPrincipalName;
printf("%d at 6\n",i++);
in1.validationFactors = &validationFactors;
printf("%d at 6\n",i++);
ns1__authenticatePrincipal.in0 = &in0;
printf("%d at 6\n",i++);
ns1__authenticatePrincipal.in1 = &in1;
printf("%d at 6\n",i++);


    if(soap_call___ns1__authenticatePrincipal(soap,
            inAddress/*endpoint*/,
            NULL/*soapAction*/, 
            &ns1__authenticatePrincipal,
            &ns1__authenticatePrincipalResponse)== SOAP_OK){
printf("%d at 6\n",i++);
        printf("ok %s\n",ns1__authenticatePrincipalResponse.out);
printf("%d at 6\n",i++);
           strNew = strcopy2(ns1__authenticatePrincipalResponse.out);
printf("%d at 6\n",i++);

    }else{
printf("%d at 6\n",i++);
        soap_print_fault(soap, stderr);
printf("%d at 6\n",i++);
    }
printf("%d at 6\n",i++);
    soap_destroy(soap);
printf("%d at 6\n",i++);
    soap_end(soap); 
printf("%d at 6\n",i++);
    soap_done(soap); 
printf("%d at 6\n",i++);
    free(soap);
printf("%d at 6\n",i++);
    return strNew;
}


int isValidPrincipalToken(char *inAddress, char *inAppName, 
        char *inAppToken, char *inCookeValPrincipalToken, char *remoteAddress,
        char *agent, char *remoteAddressXForwardFor)
{
int isValid = 0;//1=true
int i = 0;
int totFactorsIdx = 0;
int totFactors = 0;

if(agent!=NULL){
totFactors++;
}

if(remoteAddress!=NULL){
totFactors++;
}

if(remoteAddressXForwardFor != NULL && remoteAddress != NULL &&  0 != strcmp (remoteAddress, remoteAddressXForwardFor)){
totFactors++;
}


printf("totFactors=%d",totFactors);
printf("%d at 5\n",i++);
    struct soap *soap = soap_new1(SOAP_IO_DEFAULT); 
printf("%d at 5\n",i++);
    struct _ns1__isValidPrincipalTokenResponse ns1__isValidPrincipalTokenResponse;
printf("%d at 5\n",i++);
    struct _ns1__isValidPrincipalToken ns1__isValidPrincipalToken;
printf("%d at 5\n",i++);
    struct ns2__AuthenticatedToken in0;
printf("%d at 5\n",i++);
    struct ns2__ArrayOfValidationFactor validationFactors;
printf("%d at 5\n",i++);
    struct ns2__ValidationFactor ValidationFactor[3];
printf("%d at 5\n",i++);


if(agent!=NULL){
printf("%d at 5\n",i++);
    ValidationFactor[totFactorsIdx].name="User-Agent";
printf("%d at 5\n",i++);
    ValidationFactor[totFactorsIdx].value=agent;
printf("%d at 5\n",i++);
totFactorsIdx++;
}

if(remoteAddress!=NULL){
printf("%d at 5\n",i++);
    ValidationFactor[totFactorsIdx].name="remote_address";
printf("%d at 5\n",i++);
    ValidationFactor[totFactorsIdx].value=remoteAddress;
printf("%d at 5\n",i++);
totFactorsIdx++;
}

if(remoteAddressXForwardFor != NULL && remoteAddress != NULL &&  0 != strcmp (remoteAddress, remoteAddressXForwardFor)){
    ValidationFactor[totFactorsIdx].name="X-Forwarded-For";
printf("%d at 5\n",i++);
    ValidationFactor[totFactorsIdx].value=remoteAddressXForwardFor;
printf("%d at 5\n",i++);
totFactorsIdx++;
}


printf("%d at 5\n",i++);
    validationFactors.__sizeValidationFactor=totFactors;
printf("%d at 5\n",i++);
    validationFactors.ValidationFactor=ValidationFactor;

printf("%d at 5\n",i++);
in0.name = inAppName;
printf("%d at 5\n",i++);
in0.token = inAppToken;
printf("%d at 5\n",i++);
ns1__isValidPrincipalToken.in0 = &in0;
printf("%d at 5\n",i++);
ns1__isValidPrincipalToken.in1 = inCookeValPrincipalToken;
printf("%d at 5\n",i++);
ns1__isValidPrincipalToken.in2 = &validationFactors;
printf("%d at 5\n",i++);




    if(soap_call___ns1__isValidPrincipalToken(soap,
            inAddress/*endpoint*/,
            NULL/*soapAction*/, 
            &ns1__isValidPrincipalToken,
            &ns1__isValidPrincipalTokenResponse)== SOAP_OK){
printf("%d at 5\n",i++);
        printf("ok %d\n",ns1__isValidPrincipalTokenResponse.out);
printf("%d at 5\n",i++);
           isValid = ns1__isValidPrincipalTokenResponse.out;
printf("%d at 5\n",i++);

    }else{
printf("%d at 5\n",i++);
        soap_print_fault(soap, stderr);
printf("%d at 5\n",i++);
    }
printf("%d at 5\n",i++);
    soap_destroy(soap);
printf("%d at 5\n",i++);
    soap_end(soap); 
printf("%d at 5\n",i++);
    soap_done(soap); 
printf("%d at 5\n",i++);
    free(soap);
printf("%d at 5\n",i++);
    return isValid;
}


char* getDomain(char *inAddress, char *inAppName, 
        char *inAppToken)
{
char *strNew = NULL;
int i = 0;

printf("%d at 4\n",i++);
    struct soap *soap = soap_new1(SOAP_IO_DEFAULT); 
printf("%d at 4\n",i++);
    struct _ns1__getDomainResponse ns1__getDomainResponse;
printf("%d at 4\n",i++);
    struct _ns1__getDomain ns1__getDomain;
printf("%d at 4\n",i++);
    struct ns2__AuthenticatedToken in0;
printf("%d at 4\n",i++);
    in0.name = inAppName;
printf("%d at 4\n",i++);
    in0.token = inAppToken;
printf("%d at 4\n",i++);
    ns1__getDomain.in0 = &in0;
printf("%d at 4\n",i++);



    if(soap_call___ns1__getDomain(soap,
            inAddress/*endpoint*/,
            NULL/*soapAction*/, 
            &ns1__getDomain,
            &ns1__getDomainResponse)== SOAP_OK){
printf("%d at 4\n",i++);
        printf("getDomain ok %s\n",ns1__getDomainResponse.out);
printf("%d at 4\n",i++);
           strNew = strcopy2(ns1__getDomainResponse.out);
printf("%d at 4\n",i++);

    }else{
printf("%d at 4\n",i++);
        soap_print_fault(soap, stderr);
printf("%d at 4\n",i++);
    }
printf("%d at 4\n",i++);
    soap_destroy(soap);
printf("%d at 4\n",i++);
    soap_end(soap); 
printf("%d at 4\n",i++);
    soap_done(soap); 
printf("%d at 4\n",i++);
    free(soap);
printf("%d at 4\n",i++);
    return strNew;
}

char* authenticateApplication(char *inAddress, char *inAppName, 
        char *inAppPassword, char *remoteAddress,
        char *agent, char *remoteAddressXForwardFor)
{
char *strNew = NULL;
int i = 0;
int totFactorsIdx = 0;
int totFactors = 0;

if(agent!=NULL){
totFactors++;
}

if(remoteAddress!=NULL){
totFactors++;
}

if(remoteAddressXForwardFor != NULL && remoteAddress != NULL &&  0 != strcmp (remoteAddress, remoteAddressXForwardFor)){
totFactors++;
}

printf("totFactors=%d",totFactors);
printf("%d at 3\n",i++);
    struct soap *soap = soap_new1(SOAP_IO_DEFAULT); 
printf("%d at 3\n",i++);
    struct _ns1__authenticateApplicationResponse ns1__authenticateApplicationResponse;
printf("%d at 3\n",i++);
    struct _ns1__authenticateApplication ns1__authenticateApplication;
printf("%d at 3\n",i++);
    struct ns2__ApplicationAuthenticationContext in0;
printf("%d at 3\n",i++);
    struct ns2__ArrayOfValidationFactor validationFactors;
printf("%d at 3\n",i++);
    struct ns2__ValidationFactor ValidationFactor[3];
printf("%d at 3\n",i++);
    struct ns2__PasswordCredential credential;
printf("%d at 3\n",i++);


if(agent!=NULL){
printf("%d at 3\n",i++);
    ValidationFactor[totFactorsIdx].name="User-Agent";
printf("%d at 3\n",i++);
    ValidationFactor[totFactorsIdx].value=agent;
printf("%d at 3\n",i++);
totFactorsIdx++;
}

if(remoteAddress!=NULL){
printf("%d at 3\n",i++);
    ValidationFactor[totFactorsIdx].name="remote_address";
printf("%d at 3\n",i++);
    ValidationFactor[totFactorsIdx].value=remoteAddress;
printf("%d at 3\n",i++);
totFactorsIdx++;
}

if(remoteAddressXForwardFor != NULL && remoteAddress != NULL &&  0 != strcmp (remoteAddress, remoteAddressXForwardFor)){
    ValidationFactor[totFactorsIdx].name="X-Forwarded-For";
printf("%d at 3\n",i++);
    ValidationFactor[totFactorsIdx].value=remoteAddressXForwardFor;
printf("%d at 3\n",i++);
totFactorsIdx++;
}


printf("%d at 3\n",i++);
    validationFactors.__sizeValidationFactor=totFactors;
printf("%d at 3\n",i++);
    validationFactors.ValidationFactor=ValidationFactor;
printf("%d at 3\n",i++);
    in0.validationFactors = &validationFactors;
printf("%d at 3\n",i++);
    credential.credential=inAppPassword;
printf("%d at 3\n",i++);
    in0.name = inAppName;
printf("%d at 3\n",i++);
    in0.credential = &credential;
printf("%d at 3\n",i++);
    ns1__authenticateApplication.in0 = &in0;
printf("%d at 3\n",i++);



    if(soap_call___ns1__authenticateApplication(soap,
            inAddress/*endpoint*/,
            NULL/*soapAction*/, 
            &ns1__authenticateApplication,
            &ns1__authenticateApplicationResponse)== SOAP_OK){
printf("%d at 3\n",i++);
        printf("ok %s\n",ns1__authenticateApplicationResponse.out->token);
printf("%d at 3\n",i++);
           strNew = strcopy2(ns1__authenticateApplicationResponse.out->token);
printf("%d at 3\n",i++);

    }else{
printf("%d at 3\n",i++);
        soap_print_fault(soap, stderr);
printf("%d at 3\n",i++);
    }
printf("%d at 3\n",i++);
    soap_destroy(soap);
printf("%d at 3\n",i++);
    soap_end(soap); 
printf("%d at 3\n",i++);
    soap_done(soap); 
printf("%d at 3\n",i++);
    free(soap);
printf("%d at 3\n",i++);
    return strNew;
}

char * strcopy2(char *dest){

    char *strNew = NULL;
    if(dest != NULL){
        int size = strlen(dest);
        strNew = (char *)calloc(size+1,sizeof (char));
        if(strNew == NULL) {
            return NULL;
        }
        strcpy(strNew, dest);
    }
return strNew;
}





/**
 * Look through 'Cookie' header for indicated cookie; extract it
 * and URL-unescape it. Return the cookie on success, NULL on failure. 
 */
static char * getCookieValue(request_rec *r, const char *inCookieName)
{ 
    char *rawCookieStartStr = NULL;
    char *rawCookieEndStr = NULL;
    char *theCookieValue = NULL;

    /* get cookie string */
    char*rawCookieStr = (char*)apr_table_get( r->headers_in, "Cookie");
    if(!rawCookieStr) {
        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r,
                   "Crowd: No cookies set!");
        return NULL;
    }

    /* loop to search cookie name in cookie header */  
    do {
        /* search cookie name in cookie string */
        if(!(rawCookieStr =strstr(rawCookieStr, inCookieName))) {
            ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r,
                   "Crowd: Cookie not set for %s!", inCookieName);
            return NULL;
        }

        rawCookieStartStr=rawCookieStr;

        /* search '=' */
        if(!(rawCookieStr = strchr(rawCookieStr, '='))) {
            ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r,
                   "Crowd: Cookie value not set for %s!", inCookieName);
            return NULL;
        }

    } while (strncmp( inCookieName, rawCookieStartStr, rawCookieStr - rawCookieStartStr) != 0);

    /* skip '=' */
    rawCookieStr++;

    /* search end of cookie name value: ';' or end of cookie strings */
    if(!((rawCookieEndStr = strchr(rawCookieStr, ';')) || (rawCookieEndStr = strchr(rawCookieStr, '\0')))) {
        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r,
            "Crowd: Cookie value end not set for %s!", inCookieName);
        return NULL;
    }

    /* dup the value string found in apache pool and set the result pool ptr to theCookieValue ptr */
    if(!(theCookieValue = apr_pstrndup(r->pool, rawCookieStr, rawCookieEndStr-rawCookieStr))) {
        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r,
            "Crowd: Cookie copy failed for %s!", inCookieName);
        return NULL;
    }

    /* unescape the value string */
    if(!(ap_unescape_url(theCookieValue) == 0)) {
        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r,
            "Crowd: Cookie unescape failed for %s!", inCookieName);
        return NULL;
    }

    return theCookieValue;
}

static void make_cookie(request_rec *r, char *inPrincipalToken, char *inDomain, const char *inCookieName)
{

    /* 1024 == hardcoded constant */
    char cookiebuf[1024];
    char *new_cookie;
    const char *rname = ap_get_remote_host(r->connection, r->per_dir_config,
                                           REMOTE_NAME, NULL);


    /* XXX: hmm, this should really tie in with mod_unique_id */
    apr_snprintf(cookiebuf, sizeof(cookiebuf), "%s.%" APR_TIME_T_FMT, rname, 
                 apr_time_now());



    /* Cookie with date; as strftime '%a, %d-%h-%y %H:%M:%S GMT' */
    new_cookie = apr_psprintf(r->pool, "%s=%s; path=/",
                             inCookieName, inPrincipalToken);

    //using CT_NETSCAPE or CT_UNSET or CT_COOKIE1
    //no expire required
/*
    apr_time_exp_t tms;
    apr_time_exp_gmt(&tms, r->request_time 
                    + apr_time_from_sec(600));
    new_cookie = apr_psprintf(r->pool,
                                "%s; expires=%s, "
                                "%.2d-%s-%.2d %.2d:%.2d:%.2d GMT",
                                new_cookie, apr_day_snames[tms.tm_wday],
                                tms.tm_mday,
                                apr_month_snames[tms.tm_mon],
                                tms.tm_year % 100,
                                tms.tm_hour, tms.tm_min, tms.tm_sec);
*/


    if (inDomain != NULL && !strcmp (inDomain, "localhost")) {
        new_cookie = apr_pstrcat(r->pool, new_cookie, "; domain=",
                                 inDomain,
                                 "",
                                 NULL);
    }

    /* The HTTP specification says that it is legal to merge duplicate
    * headers into one.  Some browsers that support Cookies don't like
    * merged headers and prefer that each Set-Cookie header is sent
    * separately.  Lets humour those browsers by not merging.
    * Oh what a pain it is.
    */
    apr_table_t *cookie_table = apr_table_make(r->pool, 2);

    apr_table_add(cookie_table, "Set-Cookie", new_cookie);

    apr_table_add(r->err_headers_out, "Set-Cookie", new_cookie);
    apr_table_addn(r->headers_out, "Set-Cookie", new_cookie);
    apr_table_addn(r->notes, "cookie", apr_pstrdup(r->pool, cookiebuf));   /* log first time */
    return;
}

static char *lookup_header(request_rec *r, const char *name)
{
    const apr_array_header_t *hdrs_arr;
    const apr_table_entry_t *hdrs;
    int i;
    
    hdrs_arr = apr_table_elts(r->headers_in);
    hdrs = (const apr_table_entry_t *)hdrs_arr->elts;
    for (i = 0; i < hdrs_arr->nelts; ++i) {
        if (hdrs[i].key == NULL) {
            continue;
        }
        if (strcasecmp(hdrs[i].key, name) == 0) {
            return hdrs[i].val;
        }
    }
    return NULL;
}
/********************CROWD SOAP CALL FUNCS**************************/


typedef struct {
    int auth_authoritative;
    char *CrowdAppName;
    char *CrowdAppPassword;
    char *CrowdSOAPURL;
    char *CrowdCacheLocation;
    char *CrowdCacheExpiry;
    int CrowdCacheEnabled;
} auth_config_rec;

static void *create_auth_dir_config(apr_pool_t *p, char *d)
{
    auth_config_rec *conf = apr_palloc(p, sizeof(*conf));


    conf->auth_authoritative = 1; /* keep the fortress secure by default */
    conf->CrowdAppName = NULL;     
    conf->CrowdAppPassword = NULL; 
    conf->CrowdSOAPURL = NULL;
    conf->CrowdCacheLocation = NULL;
    conf->CrowdCacheExpiry = NULL;
    conf->CrowdCacheEnabled = 1;

    return conf;
}

static const char *set_auth_slot(cmd_parms *cmd, void *offset, const char *f, 
                                 const char *t)
{
    if (t && strcmp(t, "standard")) {
        return apr_pstrcat(cmd->pool, "Invalid auth file type: ", t, NULL);
    }

    return ap_set_file_slot(cmd, offset, f);
}

static const command_rec auth_cmds[] =
{
    AP_INIT_FLAG("AuthAuthoritative", ap_set_flag_slot,
                 (void *)APR_OFFSETOF(auth_config_rec, auth_authoritative),
                 OR_AUTHCFG,
                 "Set to 'no' to allow access control to be passed along to "
                 "lower modules if the UserID is not known to this module"),

    AP_INIT_TAKE12("CrowdAppName", ap_set_string_slot,
                   (void *)APR_OFFSETOF(auth_config_rec, CrowdAppName),
                   OR_AUTHCFG, "The Application Apache should authenticate as"),
    AP_INIT_TAKE12("CrowdAppPassword", ap_set_string_slot,
                   (void *)APR_OFFSETOF(auth_config_rec, CrowdAppPassword),
                   OR_AUTHCFG,
                   "The password for the Application"),
    AP_INIT_TAKE12("CrowdSOAPURL", ap_set_string_slot,
                   (void *)APR_OFFSETOF(auth_config_rec, CrowdSOAPURL),
                   OR_AUTHCFG,
                   "The URL of the Crowd SOAP service"),
    AP_INIT_TAKE12("CrowdCacheLocation", ap_set_string_slot,
                   (void *)APR_OFFSETOF(auth_config_rec, CrowdCacheLocation),
                   OR_AUTHCFG,
                   "The directory in which CrowdAuth's local cache is stored. Defaults to /tmp/FileCache if not set."),
    AP_INIT_TAKE12("CrowdCacheExpiry", ap_set_string_slot,
                   (void *)APR_OFFSETOF(auth_config_rec, CrowdCacheExpiry),
                   OR_AUTHCFG,
                   "The time (in seconds) before cached authentications in CrowdAuth's local cache expire. Defaults to 300 seconds (5 minutes)"),
    AP_INIT_FLAG("CrowdCacheEnabled", ap_set_flag_slot,
                 (void *)APR_OFFSETOF(auth_config_rec, CrowdCacheEnabled),
                 OR_AUTHCFG,
                 "Controls whether CrowdAuth caches authentications locally to improve performance. Set to on or off. Caching is on by default"),
    {NULL}
};

module AP_MODULE_DECLARE_DATA crowd_module;




/* These functions return 0 if client is OK, and proper error status
 * if not... either HTTP_UNAUTHORIZED, if we made a check, and it failed, or
 * HTTP_INTERNAL_SERVER_ERROR, if things are so totally confused that we
 * couldn't figure out how to tell if the client is authorized or not.
 *
 * If they return DECLINED, and all other modules also decline, that's
 * treated by the server core as a configuration error, logged and
 * reported as such.
 */

/* Determine user ID, and check if it really is that user, for HTTP
 * basic authentication...
 */

static int authenticate_basic_user(request_rec *r)
{
    auth_config_rec *conf = ap_get_module_config(r->per_dir_config,
                                                 &crowd_module);
    const char *sent_pw;
    char *real_pw;
    apr_status_t invalid_pw;
    int res;
    char *_AppToken = NULL;
    char *_PrincipalToken = NULL;
    char *_CookieDomain = NULL;
    int _ValidTokenBool = 0;
    const char *cookieName = "crowd.token_key";

    ap_log_rerror(APLOG_MARK, APLOG_ERR, 0, r,
                "Crowd: auth_authoritative %d, CrowdAppName %s, " \
                "CrowdAppPassword %s, CrowdSOAPURL %s, CrowdCacheLocation %s, " \
                "CrowdCacheExpiry %s, CrowdCacheEnabled %d, ",
        conf->auth_authoritative,
        (conf->CrowdAppName)?conf->CrowdAppName:"NULL",
        (conf->CrowdAppPassword)?conf->CrowdAppPassword:"NULL",
        (conf->CrowdSOAPURL)?conf->CrowdSOAPURL:"NULL",
        (conf->CrowdCacheLocation)?conf->CrowdCacheLocation:"NULL",
        (conf->CrowdCacheExpiry)?conf->CrowdCacheExpiry:"NULL",
        conf->CrowdCacheEnabled);

    if ((res = ap_get_basic_auth_pw(r, &sent_pw))) {
        return res;
    }

    if (!conf->CrowdAppName) {
        ap_log_rerror(APLOG_MARK, APLOG_ERR, 0, r,
                "Crowd: CrowdAppName not set at %s", r->uri);
        return DECLINED;
    }

    if (!conf->CrowdAppPassword) {
        ap_log_rerror(APLOG_MARK, APLOG_ERR, 0, r,
                "Crowd: CrowdAppName %s, CrowdAppPassword not set at %s", conf->CrowdAppName, r->uri);
        return DECLINED;
    }

    if (!conf->CrowdSOAPURL) {
        ap_log_rerror(APLOG_MARK, APLOG_ERR, 0, r,
                "Crowd: CrowdAppName %s, CrowdSOAPURL not set at %s", conf->CrowdAppName, r->uri);
        return DECLINED;
    }
/*
    if (!(real_pw = get_pw(r, r->user, conf->auth_pwfile))) {
        if (!(conf->auth_authoritative)) {
            return DECLINED;
        }
        ap_log_rerror(APLOG_MARK, APLOG_ERR, 0, r,
                      "user %s not found: %s", r->user, r->uri);
        ap_note_basic_auth_failure(r);
        return HTTP_UNAUTHORIZED;
    }
    invalid_pw = apr_password_validate(sent_pw, real_pw);
    if (invalid_pw != APR_SUCCESS) {
        ap_log_rerror(APLOG_MARK, APLOG_ERR, 0, r,
                      "user %s: authentication failure for \"%s\": "
                      "Password Mismatch",
                      r->user, r->uri);
        ap_note_basic_auth_failure(r);
        return HTTP_UNAUTHORIZED;
    }
*/
    char *remoteAddress = r->connection->remote_ip;
    char *agent = lookup_header(r, "User-Agent");
    char *remoteAddressXForwardFor = lookup_header(r, "X-Forwarded-For");

    if (!(_AppToken = 
        authenticateApplication( conf->CrowdSOAPURL,conf->CrowdAppName,conf->CrowdAppPassword,
                remoteAddress, agent, remoteAddressXForwardFor)
        )) {
            ap_log_rerror(APLOG_MARK, APLOG_ERR, 0, r,
                          "Crowd: CrowdAppName %s not Authorized at: %s", conf->CrowdAppName, r->uri);
            ap_note_basic_auth_failure(r);
        return HTTP_UNAUTHORIZED;
    } else {

        _CookieDomain = getDomain(conf->CrowdSOAPURL,conf->CrowdAppName, _AppToken );

        ap_log_rerror(APLOG_MARK, APLOG_ERR, 0, r,
                        "Crowd: _CookieDomain response %s found: %s", _CookieDomain, r->uri);

        //get cookie here for domain check token
        char *cookeValPrincipalToken = getCookieValue(r, cookieName);
        ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r,
                   "Crowd: Get crowd cookie %s=%s for: %s", cookieName, cookeValPrincipalToken, r->uri);


        if(cookeValPrincipalToken != NULL) {
            //fails because not setting ValidationFactors
            _ValidTokenBool =  isValidPrincipalToken(conf->CrowdSOAPURL,conf->CrowdAppName, _AppToken, cookeValPrincipalToken,
                remoteAddress, agent, remoteAddressXForwardFor);

            ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r,
                            "Crowd: _ValidTokenBool response %d found: %s", _ValidTokenBool, r->uri);
        }

        if( _ValidTokenBool == 0 ) {
            //not a ValidPrincipalToken auth again against crowd

            if (!(_PrincipalToken =  authenticatePrincipal(conf->CrowdSOAPURL, 
                            conf->CrowdAppName, _AppToken, r->user, sent_pw, 
                            remoteAddress, agent, remoteAddressXForwardFor)
                )) {

                if (!(conf->auth_authoritative)) {
                    return DECLINED;
                }
                ap_log_rerror(APLOG_MARK, APLOG_ERR, 0, r,
                              "Crowd: user %s not found: %s", r->user, r->uri);
                ap_note_basic_auth_failure(r);
                return HTTP_UNAUTHORIZED;
            }


            //set cookie here
            make_cookie(r, _PrincipalToken, _CookieDomain, cookieName);
            ap_log_rerror(APLOG_MARK, APLOG_DEBUG, 0, r,
                            "Crowd: made crowd cookie %s for: %s", cookieName, r->uri);
        }
    }

    if(_AppToken){
        free(_AppToken);
        _AppToken = NULL;
    }

    if(_PrincipalToken){
        free(_PrincipalToken);
        _PrincipalToken = NULL;
    }

    if(_CookieDomain){
        free(_CookieDomain);
        _CookieDomain = NULL;
    }



    return OK;
}


static void register_hooks(apr_pool_t *p)
{
    ap_hook_check_user_id(authenticate_basic_user,NULL,NULL,APR_HOOK_MIDDLE);

}

module AP_MODULE_DECLARE_DATA crowd_module =
{
    STANDARD20_MODULE_STUFF,
    create_auth_dir_config,     /* dir config creater */
    NULL,                       /* dir merger --- default is to override */
    NULL,                       /* server config */
    NULL,                       /* merge server config */
    auth_cmds,                  /* command apr_table_t */
    register_hooks              /* register hooks */
};

